﻿init python:

    renpy.image("hint_circle","hint_circle.png")
    se = special_effect("hint_circle")
    class registerClick(Action):
        def __call__(self):
            global num_clicks
            num_clicks += 1
            renpy.hide("hint_circle",layer='screens')
            renpy.restart_interaction()
            
            
    class getHint(Action):
        def __call__(self):
            global num_hints
            num_hints -= 1
            for index,i in enumerate(hidden_items):
                if i.found == False and i.hint == False:
                    i.hint = True
                    break
                    
            offset = Transform(xpos=i.x + (i.w/2), ypos=i.y + (i.h/2),xanchor=0.5,yanchor =0.5)
            renpy.show("hint_circle",layer='screens',at_list=[offset])
            
            renpy.restart_interaction()
            
        def get_sensitive(self):
            global num_hints
            return num_hints > 0
    class Pass(Action):
        def __call__(self):
            renpy.restart_interaction()

        def get_selected(self):
            return False
    class MakeSound(Action):
        def __call__(self):
            renpy.music.play("ow.ogg", channel="sound", loop=False)
            
    class SetItem(Action):

        def __init__(self, object, field, value):
            self.object = object
            self.field = field
            self.value = value
        
        def __call__(self):
            setattr(self.object, self.field, self.value)
            renpy.hide("hint_circle",layer='screens')
            if self.field == "found" and self.value == True:
                setattr(self.object, "listed", False)
                #store.se.setxy(self.object.x,self.object.y)
                setActive()
            renpy.restart_interaction()

        def get_selected(self):
            #return getattr(self.object, "hint") == True
            return False
            
    class Item:
        def __init__(self, name,label,x,y,w,h,hint=False):
            self.name = name
            self.label = label
            self.image = im.Crop(name,x,y,w,h)
            self.x = x
            self.y = y
            self.w = w
            self.h = h
            self.found = False
            self.listed = False
            self.hint = hint
            
    showitems = False
    def display_items_overlay():
        if showitems:
            ui.frame(id="obj_list",xalign=0.0, yalign=1.0)
            ui.hbox(id="display_hbox",spacing=10)
            ui.text("Hints: %d" % (num_hints))
            if not is_all_found():
                ui.text(" || Items:" )
                for index,i in enumerate(hidden_items):
                    if i.listed == True:
                        inventory_prefix = u"•"
                        inventory_suffix = " "
                        item_name = i.label
                        item_text = inventory_prefix+item_name+inventory_suffix
                        item_index = "object_%d" % (index)
                        ui.text(item_text,id=item_index)
            ui.close()
    config.overlay_functions.append(display_items_overlay)
    
    def is_all_found():
        for i in hidden_items:
            if i.found == False:
                return False
        return True
        
    def resetItems(in_items):
        for i in in_items:
            i.found = False
            i.active = False
    
    def setActive():
        current_listed = 0
        #counting current
        for i in hidden_items:
            if i.listed == True:
                current_listed += 1
        #adding new if necessary
        for i in hidden_items:
            if current_listed >= num_listed:
                return
            if i.listed == False and i.found == False:
                i.listed = True
                current_listed += 1
        
        
screen hidden_object:
    tag hidden
    fixed:
        add hidden_bg
        for index,item in enumerate(extra_items):
            $ image_file = item.image
            add image_file xpos item.x ypos item.y
        imagebutton idle "empty.png" hover "empty.png" action registerClick()
        textbutton "Hint" xalign 1.0 yalign 0.0 action getHint()
        for index, item in enumerate(hidden_items):
            $ image_file = item.image
            imagebutton idle image_file hover image_file insensitive "empty.png" focus_mask True xalign 0.0 yalign 0.0 xpos item.x ypos item.y action If(hidden_items[index].found==False, If(hidden_items[index].listed==True,SetItem(hidden_items[index],"found",True),Pass()), None)
        if is_all_found():
            textbutton "Objects found!" xalign 0.5 yalign 0.5 action Return("All Found")
        #add se
    use quick_menu
