#the parameter, cursorlist, expects a list of list containg an image, a pos, and an offset, with the exception that the default cursor should have "default" instead of a position


init -100 python:
    
    class special_effect(renpy.Displayable):
        
        def __init__(self, child, **kwargs):
            super(special_effect, self).__init__(**kwargs)
            
            self.x = 0
            self.y = 0
            self.child = renpy.displayable(child)
            # The alpha channel of the child.
            self.alpha = 1.0
            return
        
        def setxy(self,x,y):
            self.x = x
            self.y = y
            
        def render(self, width, height, at, st):

            # Create a transform, that can adjust the alpha channel of the
            # child.
            t = Transform(child=self.child, alpha=self.alpha)

            # Create a render from the child.
            child_render = renpy.render(t, width, height, st, at)

            # Get the size of the child.
            self.width, self.height = child_render.get_size()

            # Create the render we will return.
            render = renpy.Render(self.width, self.height)

            # Blit (draw) the child's render to our render.
            render.blit(child_render, (self.x - (self.width / 2), self.y - (self.height / 2)))

            # Return the render.
            return render
            
        def event(self, ev, x, y, st):
            renpy.redraw(self, 0)
            # Pass the event to our child.
            return self.child.event(ev, x, y, st)
                        
        def visit(self):
            return [self.child]
            
            
